The Design and Implementation of the FreeBSD Operating System, Second Edition
Now available: The Design and Implementation of the FreeBSD Operating System (Second Edition)


[ source navigation ] [ diff markup ] [ identifier search ] [ freetext search ] [ file search ] [ list types ] [ track identifier ]

FreeBSD/Linux Kernel Cross Reference
sys/scripts/gen_initramfs_list.sh

Version: -  FREEBSD  -  FREEBSD-13-STABLE  -  FREEBSD-13-0  -  FREEBSD-12-STABLE  -  FREEBSD-12-0  -  FREEBSD-11-STABLE  -  FREEBSD-11-0  -  FREEBSD-10-STABLE  -  FREEBSD-10-0  -  FREEBSD-9-STABLE  -  FREEBSD-9-0  -  FREEBSD-8-STABLE  -  FREEBSD-8-0  -  FREEBSD-7-STABLE  -  FREEBSD-7-0  -  FREEBSD-6-STABLE  -  FREEBSD-6-0  -  FREEBSD-5-STABLE  -  FREEBSD-5-0  -  FREEBSD-4-STABLE  -  FREEBSD-3-STABLE  -  FREEBSD22  -  l41  -  OPENBSD  -  linux-2.6  -  MK84  -  PLAN9  -  xnu-8792 
SearchContext: -  none  -  3  -  10 

    1 #!/bin/sh
    2 # Copyright (C) Martin Schlemmer <azarah@nosferatu.za.org>
    3 # Copyright (C) 2006 Sam Ravnborg <sam@ravnborg.org>
    4 #
    5 # Released under the terms of the GNU GPL
    6 #
    7 # Generate a cpio packed initramfs. It uses gen_init_cpio to generate
    8 # the cpio archive, and then compresses it.
    9 # The script may also be used to generate the inputfile used for gen_init_cpio
   10 # This script assumes that gen_init_cpio is located in usr/ directory
   11 
   12 # error out on errors
   13 set -e
   14 
   15 usage() {
   16 cat << EOF
   17 Usage:
   18 $0 [-o <file>] [-u <uid>] [-g <gid>] {-d | <cpio_source>} ...
   19         -o <file>      Create compressed initramfs file named <file> using
   20                        gen_init_cpio and compressor depending on the extension
   21         -u <uid>       User ID to map to user ID 0 (root).
   22                        <uid> is only meaningful if <cpio_source> is a
   23                        directory.  "squash" forces all files to uid 0.
   24         -g <gid>       Group ID to map to group ID 0 (root).
   25                        <gid> is only meaningful if <cpio_source> is a
   26                        directory.  "squash" forces all files to gid 0.
   27         <cpio_source>  File list or directory for cpio archive.
   28                        If <cpio_source> is a .cpio file it will be used
   29                        as direct input to initramfs.
   30         -d             Output the default cpio list.
   31 
   32 All options except -o and -l may be repeated and are interpreted
   33 sequentially and immediately.  -u and -g states are preserved across
   34 <cpio_source> options so an explicit "-u 0 -g 0" is required
   35 to reset the root/group mapping.
   36 EOF
   37 }
   38 
   39 # awk style field access
   40 # $1 - field number; rest is argument string
   41 field() {
   42         shift $1 ; echo $1
   43 }
   44 
   45 list_default_initramfs() {
   46         # echo usr/kinit/kinit
   47         :
   48 }
   49 
   50 default_initramfs() {
   51         cat <<-EOF >> ${output}
   52                 # This is a very simple, default initramfs
   53 
   54                 dir /dev 0755 0 0
   55                 nod /dev/console 0600 0 0 c 5 1
   56                 dir /root 0700 0 0
   57                 # file /kinit usr/kinit/kinit 0755 0 0
   58                 # slink /init kinit 0755 0 0
   59         EOF
   60 }
   61 
   62 filetype() {
   63         local argv1="$1"
   64 
   65         # symlink test must come before file test
   66         if [ -L "${argv1}" ]; then
   67                 echo "slink"
   68         elif [ -f "${argv1}" ]; then
   69                 echo "file"
   70         elif [ -d "${argv1}" ]; then
   71                 echo "dir"
   72         elif [ -b "${argv1}" -o -c "${argv1}" ]; then
   73                 echo "nod"
   74         elif [ -p "${argv1}" ]; then
   75                 echo "pipe"
   76         elif [ -S "${argv1}" ]; then
   77                 echo "sock"
   78         else
   79                 echo "invalid"
   80         fi
   81         return 0
   82 }
   83 
   84 list_print_mtime() {
   85         :
   86 }
   87 
   88 print_mtime() {
   89         local my_mtime="0"
   90 
   91         if [ -e "$1" ]; then
   92                 my_mtime=$(find "$1" -printf "%T@\n" | sort -r | head -n 1)
   93         fi
   94 
   95         echo "# Last modified: ${my_mtime}" >> ${output}
   96         echo "" >> ${output}
   97 }
   98 
   99 list_parse() {
  100         [ ! -L "$1" ] && echo "$1 \\" || :
  101 }
  102 
  103 # for each file print a line in following format
  104 # <filetype> <name> <path to file> <octal mode> <uid> <gid>
  105 # for links, devices etc the format differs. See gen_init_cpio for details
  106 parse() {
  107         local location="$1"
  108         local name="/${location#${srcdir}}"
  109         # change '//' into '/'
  110         name=$(echo "$name" | sed -e 's://*:/:g')
  111         local mode="$2"
  112         local uid="$3"
  113         local gid="$4"
  114         local ftype=$(filetype "${location}")
  115         # remap uid/gid to 0 if necessary
  116         [ "$root_uid" = "squash" ] && uid=0 || [ "$uid" -eq "$root_uid" ] && uid=0
  117         [ "$root_gid" = "squash" ] && gid=0 || [ "$gid" -eq "$root_gid" ] && gid=0
  118         local str="${mode} ${uid} ${gid}"
  119 
  120         [ "${ftype}" = "invalid" ] && return 0
  121         [ "${location}" = "${srcdir}" ] && return 0
  122 
  123         case "${ftype}" in
  124                 "file")
  125                         str="${ftype} ${name} ${location} ${str}"
  126                         ;;
  127                 "nod")
  128                         local dev=`LC_ALL=C ls -l "${location}"`
  129                         local maj=`field 5 ${dev}`
  130                         local min=`field 6 ${dev}`
  131                         maj=${maj%,}
  132 
  133                         [ -b "${location}" ] && dev="b" || dev="c"
  134 
  135                         str="${ftype} ${name} ${str} ${dev} ${maj} ${min}"
  136                         ;;
  137                 "slink")
  138                         local target=`readlink "${location}"`
  139                         str="${ftype} ${name} ${target} ${str}"
  140                         ;;
  141                 *)
  142                         str="${ftype} ${name} ${str}"
  143                         ;;
  144         esac
  145 
  146         echo "${str}" >> ${output}
  147 
  148         return 0
  149 }
  150 
  151 unknown_option() {
  152         printf "ERROR: unknown option \"$arg\"\n" >&2
  153         printf "If the filename validly begins with '-', " >&2
  154         printf "then it must be prefixed\n" >&2
  155         printf "by './' so that it won't be interpreted as an option." >&2
  156         printf "\n" >&2
  157         usage >&2
  158         exit 1
  159 }
  160 
  161 list_header() {
  162         :
  163 }
  164 
  165 header() {
  166         printf "\n#####################\n# $1\n" >> ${output}
  167 }
  168 
  169 # process one directory (incl sub-directories)
  170 dir_filelist() {
  171         ${dep_list}header "$1"
  172 
  173         srcdir=$(echo "$1" | sed -e 's://*:/:g')
  174         dirlist=$(find "${srcdir}" -printf "%p %m %U %G\n")
  175 
  176         # If $dirlist is only one line, then the directory is empty
  177         if [  "$(echo "${dirlist}" | wc -l)" -gt 1 ]; then
  178                 ${dep_list}print_mtime "$1"
  179 
  180                 echo "${dirlist}" | \
  181                 while read x; do
  182                         ${dep_list}parse ${x}
  183                 done
  184         fi
  185 }
  186 
  187 # if only one file is specified and it is .cpio file then use it direct as fs
  188 # if a directory is specified then add all files in given direcotry to fs
  189 # if a regular file is specified assume it is in gen_initramfs format
  190 input_file() {
  191         source="$1"
  192         if [ -f "$1" ]; then
  193                 ${dep_list}header "$1"
  194                 is_cpio="$(echo "$1" | sed 's/^.*\.cpio\(\..*\)\?/cpio/')"
  195                 if [ $2 -eq 0 -a ${is_cpio} = "cpio" ]; then
  196                         cpio_file=$1
  197                         echo "$1" | grep -q '^.*\.cpio\..*' && is_cpio_compressed="compressed"
  198                         [ ! -z ${dep_list} ] && echo "$1"
  199                         return 0
  200                 fi
  201                 if [ -z ${dep_list} ]; then
  202                         print_mtime "$1" >> ${output}
  203                         cat "$1"         >> ${output}
  204                 else
  205                         echo "$1 \\"
  206                         cat "$1" | while read type dir file perm ; do
  207                                 if [ "$type" = "file" ]; then
  208                                         echo "$file \\";
  209                                 fi
  210                         done
  211                 fi
  212         elif [ -d "$1" ]; then
  213                 dir_filelist "$1"
  214         else
  215                 echo "  ${prog}: Cannot open '$1'" >&2
  216                 exit 1
  217         fi
  218 }
  219 
  220 prog=$0
  221 root_uid=0
  222 root_gid=0
  223 dep_list=
  224 cpio_file=
  225 cpio_list=
  226 output="/dev/stdout"
  227 output_file=""
  228 is_cpio_compressed=
  229 compr="gzip -n -9 -f"
  230 
  231 arg="$1"
  232 case "$arg" in
  233         "-l")   # files included in initramfs - used by kbuild
  234                 dep_list="list_"
  235                 echo "deps_initramfs := $0 \\"
  236                 shift
  237                 ;;
  238         "-o")   # generate compressed cpio image named $1
  239                 shift
  240                 output_file="$1"
  241                 cpio_list="$(mktemp ${TMPDIR:-/tmp}/cpiolist.XXXXXX)"
  242                 output=${cpio_list}
  243                 echo "$output_file" | grep -q "\.gz$" && compr="gzip -n -9 -f"
  244                 echo "$output_file" | grep -q "\.bz2$" && compr="bzip2 -9 -f"
  245                 echo "$output_file" | grep -q "\.lzma$" && compr="lzma -9 -f"
  246                 echo "$output_file" | grep -q "\.xz$" && \
  247                                 compr="xz --check=crc32 --lzma2=dict=1MiB"
  248                 echo "$output_file" | grep -q "\.lzo$" && compr="lzop -9 -f"
  249                 echo "$output_file" | grep -q "\.cpio$" && compr="cat"
  250                 shift
  251                 ;;
  252 esac
  253 while [ $# -gt 0 ]; do
  254         arg="$1"
  255         shift
  256         case "$arg" in
  257                 "-u")   # map $1 to uid=0 (root)
  258                         root_uid="$1"
  259                         shift
  260                         ;;
  261                 "-g")   # map $1 to gid=0 (root)
  262                         root_gid="$1"
  263                         shift
  264                         ;;
  265                 "-d")   # display default initramfs list
  266                         default_list="$arg"
  267                         ${dep_list}default_initramfs
  268                         ;;
  269                 "-h")
  270                         usage
  271                         exit 0
  272                         ;;
  273                 *)
  274                         case "$arg" in
  275                                 "-"*)
  276                                         unknown_option
  277                                         ;;
  278                                 *)      # input file/dir - process it
  279                                         input_file "$arg" "$#"
  280                                         ;;
  281                         esac
  282                         ;;
  283         esac
  284 done
  285 
  286 # If output_file is set we will generate cpio archive and compress it
  287 # we are careful to delete tmp files
  288 if [ ! -z ${output_file} ]; then
  289         if [ -z ${cpio_file} ]; then
  290                 timestamp=
  291                 if test -n "$KBUILD_BUILD_TIMESTAMP"; then
  292                         timestamp="$(date -d"$KBUILD_BUILD_TIMESTAMP" +%s || :)"
  293                         if test -n "$timestamp"; then
  294                                 timestamp="-t $timestamp"
  295                         fi
  296                 fi
  297                 cpio_tfile="$(mktemp ${TMPDIR:-/tmp}/cpiofile.XXXXXX)"
  298                 usr/gen_init_cpio $timestamp ${cpio_list} > ${cpio_tfile}
  299         else
  300                 cpio_tfile=${cpio_file}
  301         fi
  302         rm ${cpio_list}
  303         if [ "${is_cpio_compressed}" = "compressed" ]; then
  304                 cat ${cpio_tfile} > ${output_file}
  305         else
  306                 (cat ${cpio_tfile} | ${compr}  - > ${output_file}) \
  307                 || (rm -f ${output_file} ; false)
  308         fi
  309         [ -z ${cpio_file} ] && rm ${cpio_tfile}
  310 fi
  311 exit 0

Cache object: bd2cfc88acbd11939f2b10ce4a28d816


[ source navigation ] [ diff markup ] [ identifier search ] [ freetext search ] [ file search ] [ list types ] [ track identifier ]


This page is part of the FreeBSD/Linux Linux Kernel Cross-Reference, and was automatically generated using a modified version of the LXR engine.